#include <Wire.h>

//  *****************************************************************************************************************
//  *                                                                                                               *
//  *                                         SpikenzieLabs.com                                                     *
//  *                                                                                                               *
//  *                                          POVARD Loader V2                                                     *
//  *                                                                                                               *
//  *****************************************************************************************************************
//
// BY: MARK DEMERS 
// Copyright Dec. 2010, all rights reserved
//
//
// ---------------------------------------------- YOUR MESSAGE -----------------------------------------------------
//
//                  123456789012345678901234 <- MAX SIZE 24 CHARACTERS
char message[] =   "Hello";
// -----------------------------------------------------------------------------------------------------------------
//
//
//
//
// ----------------------------------------------- Advanced Settings -----------------------------------------------
//

uint8_t Kerning = 1;               // <- Space between letters. (1 is default)
uint8_t PhraseSpace = 15;          // <- Space between Phrases. (15 is default)
uint8_t PixelTime = 20;            // <- Timing factor. Moving the Povard too fast - increase this number (200 micro second / per)
// Note: each (value from 0 to 254 only - 20 is default)
//
uint8_t RepeatTimes = 0;           // Number of times message is repeated before it stops. (0 is default)               < - NEW
// Restarts on power button press or Aux button press.
// Note: Zero (0) value for RepeatTimes makes message repeat continuously.
//
boolean InvertText = false;        // <- Invert lit or not LEDs (false is default ~ true does not look as good)
boolean FlipText = true;           // <- Flip letters (Display your letters upside down eg: ^ v)
//
// ----------------------------------------------- Custom Characters -----------------------------------------------
//
boolean CUSTOMFLAG = false;        // <- set to true to use your custom graphics 
const uint8_t CUSTOMSIZE = 3;      // <- Number of 5 element rows in your custom graphics
//
const byte CUSTOM[int(CUSTOMSIZE)][5] = {
  6,31,63,126,252,  // Heart 1     // Remember to set Kerning to 0, or there will be a split in the graphic.
  126,63,31,6,0,    // Heart 2     // This is an example custom graphic of a heart.
  0,0,0,0,0, 
};
//
//
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Bit Map Letter - data array
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const byte LETTERS[95][5] = {
  0,0,0,0,0,            // Space
  0,0,95,0,0,           // !
  0,3,0,3,0,            // "
  18,63,18,63,18,       // #
  4,42,127,42,16,       // $
  34,21,42,84,34,       // %
  54,73,81,34,80,       // &
  0,0,3,0,0,            // '
  0,28,34,65,0,         // (
  0,65,34,28,0,         // (
  4,20,15,20,4,         // *
  8,8,62,8,8,           // +
  0,0,2,1,0,            // ' (not sure)
  8,8,8,8,8,            // -
  0,0,64,0,0,           // .
  32,16,8,4,2,          // /

  62,65,65,65,62,        // 0
  64,66,127,64,64,       // 1
  98,81,73,73,70,        // 2
  34,65,73,73,54,        // 3
  7,8,8,127,8,           // 4
  47,73,73,73,49,        // 5
  62,73,73,73,50,        // 6
  65,33,17,9,7,          // 7
  54,73,73,73,54,        // 8
  6,9,9,9,126,           // 9

  0,0,54,0,0,            // :
  0,64,54,0,0,           // ;
  8,20,34,65,0,          // <
  20,20,20,20,20,        // =
  0,65,34,20,8,          // >
  6,1,81,9,6,            // ?
  62,65,73,85,10,        // @

  124,10,9,10,124,       // A
  127,73,73,73,54,       // B
  62,65,65,65,34,        // C
  127,65,65,65,62,       // D
  127,73,73,73,65,       // E
  127,9,9,9,1,           // F
  62,65,73,73,50,        // G
  127,8,8,8,127,         // H
  65,65,127,65,65,       // I
  32,64,65,63,1,         // J
  127,8,20,34,65,        // K
  127,64,64,64,64,       // L
  127,2,4,2,127,         // M
  127,4,8,16,127,        // N
  62,65,65,65,62,        // O
  127,9,9,9,6,           // P
  62,65,81,33,94,        // Q
  127,9,25,41,70,        // R
  38,73,73,73,50,        // S
  1,1,127,1,1,           // T
  63,64,64,64,63,        // U
  31,32,64,32,31,        // V
  63,64,48,64,63,        // W
  99,20,8,20,99,         // X
  3,4,120,4,3,           // Y
  97,81,73,69,67,        // Z

  0,127,65,65,0,         // [
  2,4,8,16,32,           // back slash
  0,65,65,127,0,         // ]
  0,2,1,2,0,             // ^
  128,128,128,128,128,   // _
  0,0,1,2,0,             // `

  112,72,72,40,120,       // a
  126,48,72,72,48,        // b
  48,72,72,72,72,         // c
  48,72,72,48,126,        // d
  56,84,84,84,88,         // e
  0,8,124,10,0,           // f
  36,74,74,74,60,         // g
  126,8,8,8,112,          // h
  0,0,122,0,0,            // i
  32,64,66,62,2,          // j
  124,16,16,40,68,        // k
  0,124,64,64,0,          // l
  120,4,120,4,120,        // m
  124,8,4,4,120,          // n
  48,72,72,72,48,         // o
  126,18,18,18,12,        // p
  12,18,18,18,124,        // q
  124,8,4,4,8,            // r
  72,84,84,84,36,         // s
  4,4,126,4,4,            // t
  60,64,64,64,60,         // u
  28,32,64,32,28,         // v
  124,32,16,32,124,       // w
  68,40,16,40,68,         // x
  4,8,112,8,4,            // y
  68,100,84,76,68,        // z

  0,8,54,65,0,            // {
  0,0,127,0,0,            // |
  0,65,54,8,0,            // }
  16,8,24,16,8,           // ~
};

//
// NOTES:
//
// Bit map is coded from left to right, fixed space 5x8 matix. Where 1 (LSB) is top position of matrix.
//
// Example: Letter "T" is 1,1,127,1,1
// T = xxxxx
//       x
//       x
//       x
//       x
//       x
//       x
//              < - This row is blank (or used to underline)
// 
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Changes: for V2 Dec 2010
// Bug with Povard and new version of Arduino IDE, caused I2C request not to work if followed by I2C received data.
// Old method - Povard "asked" Arduino for specific data (like from a specific EEPROM memory location)
// New method - Povard asks how much data (variable with message size) and then does sequential requests.

#include <Wire.h>                                              // Used for the I2C Communications

#define         POVARD	        0x50        // I2C Address (Wire Lib shifts one bit to right (is 0xA0))

#define         LEDPIN          13                             // Use on board LED to flash status

#define         POWERPIN        PORTC2                         // Arduino analog pins used to power
#define         GROUNDPIN       PORTC3

#define         PROGPIN         PORTC1                         // Arduino analog pins used set POVARD in prog mode


volatile uint8_t REQUESTADD = 0;
volatile uint8_t i2cdata = 0;
volatile uint8_t outdata = 0;
volatile uint8_t memoryadd = 0;

int STATE = 0;
int index = 0;
int delcount = 0;
byte SliceIndex = 0;
int selet = 0;
int letter = 0;
int slice = 0;
int maxslice = 0;

boolean ProgramStart = false;

unsigned char msize = 0;

volatile uint8_t RequestStep = 1;


void setup() 
{
  pinMode(LEDPIN, OUTPUT);
  digitalWrite(LEDPIN, HIGH);

  PORTC = PORTC &~ (1 << GROUNDPIN);                            // Set the GROUNDPIN to LOW
  PORTC = PORTC &~ (1 << PROGPIN);                              // Set the PROGPIN to LOW

  // new
  PORTC = PORTC &~ (1 << POWERPIN);                             // Set the PowerPin to LOW
  delay(100);

  DDRC = DDRC | 1 << POWERPIN;                                  // Make these pins outputs
  DDRC = DDRC | 1 << GROUNDPIN;
  DDRC = DDRC | 1 << PROGPIN;

  Wire.begin(POVARD);

  TWBR = ((F_CPU / 32000l) - 16) / 2;

  delay(100);  
  PORTC = PORTC | 1 << POWERPIN;                                // Set the POWERPIN to HIGH                                              

  Wire.onReceive(myReceiveHandler);
  Wire.onRequest(myRequestHandler);

  msize = sizeof(message) -1;
  maxslice = int(msize) * 5;
  if(CUSTOMFLAG == true)
  {
    maxslice = CUSTOMSIZE * 5;
  }


}

void loop()
{
  switch (STATE) 
  {
  case 0:                                      // Waiting / programming
    if(ProgramStart == true)
    {
      digitalWrite(LEDPIN, LOW);
    }
    else
    {
      digitalWrite(LEDPIN, HIGH);
    }

    delcount = 0;
    break;


  case 1:                                      // Done Flash LED-ON
    digitalWrite(LEDPIN, HIGH);
    delay(1000);
    digitalWrite(LEDPIN, LOW);  
    delay(1000);
    break;

  }
}

void myReceiveHandler(int numBytes)
{

  while(Wire.available())
  {
    i2cdata = Wire.receive();
  }

}


void myRequestHandler()
{
  
  switch(RequestStep)
  {

  case 1:                          // Message size requested from POVARD (Programming started)
    if(CUSTOMFLAG == true)
    {
      Wire.send(CUSTOMSIZE);
    }
    else
    {
      Wire.send(msize);
    }

    STATE = 0;
    digitalWrite(LEDPIN, LOW);
    ProgramStart = true;
    SliceIndex = 0; 

    RequestStep = RequestStep +1;   
    break;

  case 2:                          // Letter Kerning value
    Wire.send(Kerning);
    RequestStep = RequestStep +1; 
    break;    

  case 3:                          // Phrase Spacing Kerning value
    Wire.send(PhraseSpace);
    RequestStep = RequestStep +1; 
    break;  

  case 4:                          // Invert lit and not lit LEDs
    if(InvertText == true)
    {
      Wire.send(1);
    }
    else
    {
      Wire.send(0);
    }
    RequestStep = RequestStep +1; 
    break; 

  case 5:                          // Time the LEDs are lit
    Wire.send(PixelTime);
    RequestStep = RequestStep +1; 
    break;  
  
  case 6:                                               // Times to Repeat message before stopping 
    Wire.send(RepeatTimes);
    RequestStep = RequestStep +1; 
    break;     

  case 7:                                               // UPLOADING letter data to POVARD
    letter = SliceIndex /  5;                           // Gives position in message (0 to size)

    slice = SliceIndex % 5;                             // Gives sub-position in letter (0 to 4)

    outdata = 0; 

    if(message[letter]>31 && message[letter] < 127)     // Visible letters
    {
      selet = message[letter] - 32;                     // Our position 0 is 32nd ASCII characters
      outdata = LETTERS[selet][slice];
    }

    if(CUSTOMFLAG == true)
    {
      outdata = CUSTOM[letter][slice];
    }


    if(InvertText == true)
    {
      outdata = ~outdata;
    }

    if(FlipText == true)
    {
      uint8_t temp = 0;
      for(int i=0; i<8; i++)
      {
        if(bitRead(outdata, i) == B1)
        {
          bitSet(temp,(7-i));
        }
      }
      outdata = temp;
    }
    Wire.send(outdata);

    SliceIndex = SliceIndex +1;

    if(SliceIndex >= maxslice)
    {
      SliceIndex = 0;   
      RequestStep = RequestStep +1;       
    }
    break;

  case 8:                          // Finished uploading letter data to POVARD
    STATE = 1;
    delcount = 0;
    RequestStep = 1; 
    Wire.send(0);
    break; 
  }
}

